#define version "16 LCD jumbo HR"
//               123456789123456    11/06/2013
//**********************************************************
// BIBLIOTHEQUES
// incluses dans le package Arduino de base
// *** LCD *** afficheur LCD
//#include <LiquidCrystal.h>  // LCD+

// ajoutées
// *** GENERAL *** formatage des entrees sorties ASCII
#include <Streaming.h>
// *** TEMPS ***
#include <Time.h>

//**********************************************************
//**********************************************************
// DECLARATIONS
// *** GENERAL *** 
/* DEBUG : 
 0=pas de debug
 1=debug minimal pour voir les étapes
 2=debug plus fin
*/
int debug=0;  
// *******************************************
// *** TEMPS *** gestion du temps
#include "decl_sp.h"

// *** Morse et musiques ***
// *** GBF *** générateur basse fréquence, pwm, servo
#define sortie_gbf 4
#define tone_mode 0		// 0=(tout ou rien pour buzzer externe) 1=tone 
#include "decl1300_morse.h"

// *** GENERAL *** 
// speedomètre = calcul de vitesse ...
unsigned int tours_ps,tours,tours_led;

/******************/
// ENTREES SORTIES

#define led 12
#define led2 8

// temporisations
int lcdj_tempo,lcdj_tempo_b,lcdj_tempo_b_reset=10000;

// grafcets
int grafcet_lcdj=0,grafcet_lcdj_old;

// variables diverses
int i,j,k;
char valuef[3];
int i2,j2;

//**********************************************************
// SOUS-PROGRAMMES
// ************************************************************************************************

//**********************************************************
// déclarations et sous-programmes pour le LCD JUMBO
#include "lcd_jumbo.h"

//**********************************************************
// gestion du temps, formatages, gestion clavier
#include "sp.h"

//**********************************************************
// INITIALISATIONS

void setup() {
// mise à l'heure
//  setSyncInterval(60);         // 5 minutes par défaut secondes set the number of seconds between re-sync
  setSyncProvider(getTimeFunction);  // set the external time provider
/*
Functions for managing the timer services are:  
setTime(t);             // set the system time to the give time t
setTime(hr,min,sec,day,mnth,yr); // alternative to above, yr is 2 or 4 digit yr (2010 or 10 sets year to 2010)
adjustTime(adjustment); // adjust system time by adding the adjustment value

timeStatus();       // indicates if time has been set and recently synchronized
                    // returns one of the following enumerations:
    timeNotSet      // the time has never been set, the clock started at Jan 1 1970
    timeNeedsSync   // the time had been set but a sync attempt did not succeed
    timeSet         // the time is set and is synced
Time and Date values are not valid if the status is timeNotSet. Otherwise values can be used but 
the returned time may have drifted if the status is timeNeedsSync. 	

setSyncProvider(getTimeFunction);  // set the external time provider
setSyncInterval(interval);         // set the number of seconds between re-sync
*/
// ligne série (pour traces)
  Serial.begin(9600);  // selon votre port COM
  horodatage_serial(); Serial << version << " debug=" << debug << endl;

// Forcage pour essayer sans CS géré ou avec moins de modules (selon lcdjx)
#if lcdjx < 1
 pinMode(37, OUTPUT);
 digitalWrite(37,LOW);
#endif
#if lcdjx < 2
 pinMode(38, OUTPUT);
 digitalWrite(38,LOW);
#endif
#if lcdjx < 3
 pinMode(39, OUTPUT);
 digitalWrite(39,LOW);
#endif

  pinMode(led, OUTPUT);
  pinMode(led2, OUTPUT);
// potentiomètre
  pinMode(A0, INPUT);

// initialisation du LCD jumbo
  lcdj_init();

  if (debug>0) horodatage_serie('d'); Serial << "Setup() fini **************************\xB0""C**" << endl;
  strncpy(lcdj_buf,version,lcdj*lcdj_nbd);
  lcdj_affiche();
  delay(2000);
}
//////////////////////////////////////////////////////////////////////////////////////////////
void loop() {

   tours++; tours_led++;
   if (tours_led>=10000) {tours_led=0; digitalWrite(led,HIGH);}
   if (tours_led==500) digitalWrite(led,LOW);

// gestion temps, temporisations (en ms) et horloge
   ger_top_centieme ();

//--------------------------------
// chaque centieme de seconde, top10 retourne le nombre de millisecondes passées :
// pourquoi pas 10 à chaque coup ? si le programme est lent, on peut avaoir dépassement, donc on essaie de récupérer au mieux !
   if (top_10 > 0) {
// gestion des TEMPORISATIONS (en ms mais précise à 10ms près)
     if (lcdj_tempo >= top_10 ) { lcdj_tempo -= top_10; } else { lcdj_tempo = 0; }
     if (lcdj_tempo_b >= top_10 ) { lcdj_tempo_b -= top_10; } else { lcdj_tempo_b = 0; }
//     if (tempo_cw >= top_10 ) { tempo_cw -= top_10; } else { tempo_cw = 0; }
// raz mémoire
     top_10 = 0;
   }

//--------------------------------
// chaque dixieme de seconde :
   if (top_100ms) {
       top_100ms = false;
       digitalWrite(led2,LOW); //!digitalRead(led2));
// affichage lcd JUMBO
       lcdj_affiche();
// réception Serial. comme on a un buffer hardware, on n'est pas 'trop' pressé !
       serial_reception();
   }  // fin dixième de seconde

//--------------------------------
// chaque quart de seconde :
   if (top_250ms) {
       top_250ms = false;
   }

//--------------------------------
// chaque demie seconde :
   if (top_500ms) {
       top_500ms = false;
   }

//--------------------------------
// chaque seconde :
   if (top_1000ms) {
       top_1000ms = false;
       digitalWrite(led2,HIGH); //!digitalRead(led2));
       tours_ps=tours; tours=0;
       if (tours_ps<10000) {horodatage_serie('d'); Serial << "ATTENTION tours_ps=" << tours_ps << " sync=" << horloge_synchro_tempo << " now=" << now() << endl; }

// gestion des TEMPORISATIONS (en secondes)
   }   // fin seconde

//--------------------------------
// chaque minute :
   if (top_60000ms) {
        top_60000ms=false;
// carillon        
//        grafcet_bigben = 1;

   }  // fin minute

//--------------------------------********************--------------------------------
//  GRAFCET DE FONCTIONNEMENT GENERAL
// trace de debug
  if (debug > 0 && grafcet_lcdj != grafcet_lcdj_old) {
     grafcet_lcdj_old = grafcet_lcdj;
     horodatage_serial(); Serial << "grafcet_lcdj=" << grafcet_lcdj << " tours_ps=" << tours_ps << endl;
  }
/*
if (debug > 0 && grafcet_cw != grafcet_cw_old) {
     grafcet_cw_old = grafcet_cw;
     horodatage_serial(); Serial << "grafcet_cw=" << grafcet_cw << " tours_ps=" << tours_ps << endl;
  }
*/

 switch (grafcet_lcdj) {
//
  case 0:    
     lcdj_clear(' ');
     grafcet_lcdj++;
     j2=0; i2=0;
   break;

// test toutes lettres AAAAAAAAAA
 case 1:    
     if (lcdj_tempo == 0 ) {
         lcdj_clear(' ');
// fin liste
       if (debug == 0 || j2>=lcdj_seg_nb) {
         grafcet_lcdj++;
         grafcet_lcdj++;
         j2=0; i2=0;
// test
       } else {
         for (i2=0;i2<lcdj*lcdj_nbd;i2++) lcdj_buf[i2]=lcdj_seg[j2].c;
         j2++;
         if (debug>1) Serial << "=" << lcdj_buf << " " << endl;
         lcdj_tempo = 200;
       }
     }
   break;

// affichage demo ABCDEF......
  case 2:
     if (lcdj_tempo == 0 ) {
       lcdj_buf[i2]=lcdj_seg[j2].c;
       j2++; i2++; if (i2>=lcdj*lcdj_nbd) i2=0;
       lcdj_tempo = 100; // 600-150*lcdj;      // à régler sur 500 ou plus pour bien lire !!
       if (debug>1) Serial << "=" << lcdj_buf << " " << endl;
     }
// fin liste
     if (j2>=lcdj_seg_nb or debug==0) grafcet_lcdj++;
    break;

// HORLOGE
  case 3:
//   if (debug>1) Serial << "second=" << second() << " t=" << lcdj_tempo << "," << lcdj_tempo_b <<endl;
   if (lcdj_tempo == 0 ) {
    if (lcdj_tempo_b == 0 ) {
//     memset (lcdj_buf,'\0',sizeof(lcdj_buf));
      lcdj_clear('\0');
//Serial << "0[" << lcdj_buf << "]" << endl;
      if (debug>1) Serial << "second=" << second() << " t=" << lcdj_tempo << endl;

// préparation du message de type hh.mm.ss/Jou .xx/mm.aaaa
/* ATTENTION !
Il faut être très prudent quand on manipule les chaines de caractères.
Tout débordement se traduit par un comportement erratique et anormal de l'ARDUINO, 
  se terminant en général par un crash et reboot.
On a donc intérêt à utiliser 'strncpy' et 'strncat' pour limiter le nombre de caractères recopiés,
  et à terminer les chaines par '\0' (d'où une longueuer+1 que j'utilise dans les déclarations)
*/
// selon secondes, affichage varie !
      switch (second()%10) {
#if lcdj < 2
// jour date
       case 6:
       case 7:
          strcpy( lcdj_buf, jours[weekday()]); strcat( lcdj_buf, " ");
          dtostrf(day(),2,0,valuef); strcat( lcdj_buf, valuef );
          if (milliseconde > 500) { strcpy( lcdj_bufdp, "      " ); } else { strncpy( lcdj_bufdp, "   .  ",6); }
          break;
// mois.annee
       case 8:
       case 9:
          dtostrf(month(),2,0,valuef); strncpy( lcdj_buf, valuef,2 );
          dtostrf(year(),4,0,valuef); strncat( lcdj_buf, valuef,4 );
          if (milliseconde > 500) { strcpy( lcdj_bufdp, "      " ); } else { strncpy( lcdj_bufdp, " .    ",6); }
          break;
#endif
// hh:mm:ss
       default:
          dtostrf(hour(),2,0,valuef); strcpy(lcdj_buf, valuef);
          dtostrf(minute(),2,0,valuef); strcat( lcdj_buf, valuef );
          dtostrf(second(),2,0,valuef); strcat( lcdj_buf, valuef );
// rajouter les zeros non significatifs
          for (i=0;i<6;i++) { if (lcdj_buf[i]==' ') lcdj_buf[i]='0'; }

#if lcdj > 2
// chenillard rigolo
          if (minute() & 1) {
            for (i=6; i < (6+second()/5); i++) lcdj_buf[i]='°' ;
// jour et date
          } else {
            strcat( lcdj_buf, jours[weekday()]); strcat( lcdj_buf, " ");
            dtostrf(day(),2,0,valuef); strcat( lcdj_buf, valuef );
            dtostrf(month(),2,0,valuef); strcat( lcdj_buf, valuef );
            dtostrf(year(),4,0,valuef); strcat( lcdj_buf, valuef );
          }
#endif

// gestion des . et :
          strncpy( lcdj_bufdp, "      ",6);
          if (milliseconde > 500) { 
// si horloge non synchro , on alterne : et .
//            if ( horloge_synchronisee != 0) { strcpy( lcdj_bufdp, " . .  " ); } else {strcpy( lcdj_bufdp, "      ");} 
            if(timeStatus() != timeSet)  strncpy( lcdj_bufdp, " . .  ",6 );
            strcpy( lcdj_bufco,   "  "); 
          } else {
            strcpy( lcdj_bufco,   "::"); 
          }

#if lcdj == 2
// jour date
       if (second()%10 < 5) {
          strncat( lcdj_buf, jours[weekday()],3); 
          dtostrf(day(),3,0,valuef); strncat( lcdj_buf, valuef,3 );
          strncat( lcdj_bufdp, "  ..  ",6 );
          strncat( lcdj_bufco, " :",2); 
// mois.annee
       } else {
          dtostrf(month(),2,0,valuef); strncat( lcdj_buf, valuef,2 );
          dtostrf(year(),4,0,valuef); strncat( lcdj_buf, valuef,4 );
          strncat( lcdj_bufdp, " .    ",6 );
          strncat( lcdj_bufco, ": ",2); 
       }
#endif

#if lcdj>2
          if (milliseconde > 500) {
            if (!(minute() & 1)) strcat ( lcdj_bufco," :: "); 
            strcat ( lcdj_bufdp,"            "); 
          } else {
            strcat ( lcdj_bufco,"    "); 
//        memset ( lcdj_bufdp,'\0',sizeof(lcdj_bufdp)); 
            if (minute() & 1) {
              strncpy( lcdj_bufdp, "      ............",6+second()%5);
            } else {
              strncpy( lcdj_bufdp, "        ..   .    ",18);
            }
//                                  123456789012345678  
          }
#endif
          break;
      }  // fin switch seconds()

// traces
      if (debug >1) Serial << "lcdj_bufxx=" << lcdj_buf << "=" << lcdj_bufdp << "=" << lcdj_bufco << "=" << endl;
    }    // fin lcdj_tempo_b

//*****
// évenement extérieur : le potentiomètre bouge ! (mais cela pourrait ÃƒÂªtre un BP, ou un message I2C)
    i2=(3*j2+analogRead(A0))/4;    // filtrage
    if (i2 != j2) {grafcet_lcdj++; lcdj_clear('\0'); }
//Serial << "A0=" << i2 << " " << j2 << endl;

//*****
// évenement extérieur : MESSAGE par la voie série type Axxxxxxx ou Mxxx
/*
lcdj_tempo_b est forcé et le msg mis dans lcdj_buf par le module msg-traitement
*/

// vitesse de mise à jour
    lcdj_tempo = 100;
   }  // fin lcdj_tempo
   break;
    

// affichage valeur potentiometre si il bouge
   case 4:
      if (lcdj_tempo == 0 ) {

//###
// si potentiomètre bouge
        i2=(3*j2+analogRead(A0))/4;    // filtrage
        if (i2 != j2) {
// conversion FLOAT CHAR
          dtostrf (i2,5,0,lcdj_buf); strcat( lcdj_buf, "        " );
// bargraphe
          if (lcdj > 1) {
            for (i=5;i<lcdj_nbd*lcdj;i++) lcdj_buf[i]=' ';
            for (i=0;i<(j2*lcdj_nbd*lcdj/1020);i++) lcdj_buf[6+i]='o'; // lcdj_seg[lcdj_seg_nb-1].c ;//'°'; 
          }          
          if (i2 > j2) {lcdj_buf[0]='+';} else {lcdj_buf[0]='_';}    // + ou -
          j2=i2;     // mémoire
          lcdj_tempo_b = lcdj_tempo_b_reset;
//          horodatage_serial(); Serial << "A0=" << j << endl;
// égalité
        } else { lcdj_buf[0]='-'; }
        
// cyclage
      lcdj_tempo = 100;
// retour mode horloge temporisé
      if (lcdj_tempo_b == 0 ) grafcet_lcdj=3;
     }
  break;
///////////////////  si grafcet_a n'a pas une valeur correcte, on passe ici
  default: 
    horodatage_serial(); Serial << "ERREUR grafcet_lcdj=" << grafcet_lcdj << endl; 
    grafcet_lcdj = 0;         // on retourne au debut
  break;
 } // fin switch grafcet_lcdj

//--------------------------------********************--------------------------------
// GRAFCET de generation de la CW
#include "graf1300_morse.h"
//--------------------------------********************--------------------------------
} // fin loop()
//--------------------------------********************--------------------------------
// S/P locaux
//--------------------------------********************--------------------------------
//--------------------------------********************--------------------------------



