// *** MORSe *** V06.06.2013
/////////////// Simple Arduino CW //////////////////
// Written by Mark VandeWettering K6HX
// Email: k...@arrl.net
//
// Thx Mark de ON7EQ !
// http://www.qsl.net/on7eq/en/index.htm
/*
Codage très astucieux de ON7EQ !!!
Les patterns sont faits comme suit :
 - Lecture de droite à gauche 
 - bit = 0 = . dit
 - bit = 1 = - dash
 - on rajoute un bit à 1 pour finir
 
Lecture : 
a/ on fait d'abord p=morsetab[i].pat 
b/ si p = 1 on Arrête
c/ si le bit de poids faible de p (à droite) = 1 = dash = trait
d/ si le bit de poids faible de p (à droite) = 0 = dot = point
e/ on divise p par 2, c'est à dire on shifte à droite de 1 bit, et on retourne en b/

exemples :
	{'C', 21},  // -.-. 0001 0101
  0001 010 1 = dash
  0000 101 0 = dot
  0000 010 1 = dash
  0000 001 0 = dot
  0000 000 1 = 1 = STOP
	{'Q', 27},	// --.- 0001 1011
  0001 101 1 = dash
  0000 110 1 = dash
  0000 011 0 = dot
  0000 001 1 = dash
  0000 000 1 = 1 = STOP
... F1FWG
*/
struct t_mtab { char c, pat; } ;
struct t_mtab morsetab[] = {
  	{'.', 106},     // .-.-.- 0110 1010
	{'1', 62},	// -.... 0011 1110
	{'2', 60},      // --... 0011 1100
	{'3', 56},      // ---.. 0011 1000
	{'4', 48},      // ----. 0011 0000
	{'5', 32},      // ..... 0010 0000
	{'6', 33},      // -.... 0010 0001
	{'7', 35},      // --... 0010 0011
	{'8', 39},      // ---.. 0010 0111
	{'9', 47},      // ----. 0010 1111
	{'0', 63},      // ----- 0011 1111
	{'A', 6},	// .-	0000 0110
	{'B', 17},      // -... 0001 0001
	{'C', 21},	// -.-.	0001 0101
	{'D', 9},       // -..  0000 1001
	{'E', 2},       // .    0000 0010
	{'F', 20},      // ..-. 0001 0100
	{'G', 11},      // --.  0000 1011
	{'H', 16},      // .... 0001 0000
	{'I', 4},       // ..   0000 0100 
	{'J', 30},      // .--- 0001 1110
	{'K', 13},	// _._	0000 1101
	{'L', 18},      // .-.. 0001 0010
	{'M', 7},	// --	0000 0111
	{'N', 5},       // -.   0000 0101
	{'O', 15},      // ---  0000 1111
	{'P', 22},      // .--. 0001 0110
	{'Q', 27},	// --.-	0001 1011
	{'R', 10},      // ._.	0000 1010
	{'S', 8},       // ...  0000 1000
	{'T', 3},	// _	0000 0011
	{'U', 12},      // ..-  0000 1100
	{'V', 24},	// ...-	0001 1000
	{'W', 14},      // .--  0000 1110
	{'X', 25},      // -..- 0001 1001
	{'Y', 29},      // -.-- 0001 1101
	{'Z', 19},      // --.. 0001 0011
	{'!', B01110101},       // -.-.--
	{'=', B00110001},       // -...-
	{'-', B01100001},       // -....-
	{'+', B00101010},       // .-.-.
	{'#', B10000000},       // .......  ERREUR
	{'$', B01010111},       // ---.-.  VA fin de de transmission
	{'*', B00100010},       // .-...  QRX attente
	{':', B01000111},       // ---...
        {'\'', B01011110},       // .----.
	{',', 115},     // --..-- 0111 0011
	{'?', 76},      // ..--.. 0100 1100
	{'/', 41}       // -..-.  0010 1001
        } ;

#define CW_N_MORSE  (sizeof(morsetab)/sizeof(morsetab[0]))
#ifndef tone_mode
#define tone_mode 1		// 0=(tout ou rien pour buzzer externe) 1=tone 
#endif
int CW_PITCH=880;               // frequence du morse TIH = POINT(880 = LA4)
int CW_PITCH_TAAH=860;          // frequence du morse TAAH = TRAIT (831 = SOL#4)
int CW_SPEED=15;		// en mots/minute (16=75ms le point)
int CW_DOTLEN=80;
int CW_DASHLEN=240;              // CW weight
int CW_DASHLEN_PROP=30;  // en dixièmes CW weight original 3 à 3.5 / 1
/* calculs à faire selon SPEED :
      CW_DOTLEN=1200/CW_SPEED;    // en millisecondes
      CW_DASHLEN=CW_DASHLEN_PROP*CW_DOTLEN/10;   // en millisecondes
*/
int grafcet_cw=1,grafcet_cw_old;    // armé en attente à priori
int tempo_cw, tempo_attcw, tempo_attcwval=2000;
char cw, pw, cwcw=0;    // caractère en cours, bit en cours, cw ou musique
int  cw_pos; // position en cours d'émission dans le buffer 'cw_texte'
char cw_texte[30];
char cw_texte_att[15],cw_texte_old[15];

// Notes de MUSIQUE (fréquences x 100 de la gamme No 3)
//                                  do   re   mi   fa  sol   la   si   
char note_name[] =              {  'c', 'd', 'e', 'f', 'g', 'a', 'b' };
unsigned int note_tone[] =      { 26163,29366,32963,34923,39199,44000,49388 };
//int note_tone[] =             { 262,  294,  330,  349,  392,  440,  494 };
float note_freq;
int duree_note=150;      // ms de base

// Constantes sympas avec une précision suffisante (Arduino gère 7 à 8 decimales)
//#define deuxpi  6.283185307 //179586476925286766559;  // à peu près 2 Pi
#ifndef racine2
#define racine2 1.414213562 //3730950488016887242097; // racine carree de 2
#endif
#ifndef demiton
#define demiton 1.059463094 //3592952645618252949463; // 2 puissance 1/12 rapport de fréquence entre 2 notes séparées d'un demi-ton
#endif


// Declarations pour horloge type BigBen
// d'après : http://en.wikipedia.org/wiki/Westminster_Quarters
/* BIG BEN
15'   0
30'   1+2
45'   3+4+0
heure 1+2+3+4
Hertz = b3=494 e4=659 f#4=740 g#4=831 BigBen=e2=165 e3=330
*/
int grafcet_bigben;
//            Chime      0                1                2                3                4   
char* bigben_chime[]={"$2g#4f#4e4$6b3","$2e4g4#f4#$6b3","$2e4f#4g#4$6e4","$2g#4e4f#4$6b3","$2b3f#4g#4$6e4"};
char* bigben ="$4e3 ";    // normalement c'est e2, mais c'est trop grave pour nous !
// pour minutes     0 15 30 45 Selon le quart d'heure, on utilise 1,2,3 ou 4 chimes, et on commence par "le suivant"
int bigben_debut[]={1, 0, 1, 3};    // chime debut
int bigben_fin[]  ={4, 0, 3, 0};    // chime fin
int bigben_i,bigben_n;
////////// end CW section ////////////


