/* V24.05.2013
	Fonctionnement :
 Pour tester si la CW est disponible : if (grafcet_cw == 1) {

 Placer dans 'cw_texte' la chaine de caractères à mettre :
    strcpy (cw_texte,"Bonjour");        // manipulera BONJOUR 
    strncpy (cw_texte,"Bonjour",3);    // manipulera BON
    strncpy (cw_texte,"abcd",4);    // sonnera LA SI DO RE
    strncp (cw_texte,"abcc#dd#");    // sonnera LA SI DO DO# RE RE#
    strncp (cw_texte,"cdefga4b4c4");    // sonnera DO RE MI FA SOL LA SI DO (3 dernières notes sur la gamme suivante, gamme 3 par defaut)

 On peut aussi charger 'cw_texte_att' qui ne sera manipulé qu'après 'tempo_attcwval' millisecondes, si il n'a pas changé ! 

 NOTES sous forme 'a' 'a#' 'a3' 'a#3' ou 'a3#'
 $n avec n=0 à 9 permet de changer la durée des notes 
 
Duree des notes : 
La vitesse doit pouvoir se régler de 40 à 200 noires/minutes (1500 à 300 ms par noire)
'0'=75ms(tempo 800 notes/minute) '9'=750ms(tempo 80 notes/minute)

Une vitesse correcte dans notre cas sera de 267 noires/minutes (225ms/noire) soit $2
double-croche=$0 croche=$1 noire=$2 blanche=$4 blanche_pointée=$6 ronde=$8

Nom                  Indication      Pulsations par minute 
Grave                très lent       40 - 44 
Largo / Larghetto    large           44 - 50 
Lento / Adagio       lent, à l'aise  50 - 60 
Andante / Andantino  en marchant     60 - 80 
Moderato             modérément      80 - 100 
Allegretto / Allegro animé          100 - 126 
Vivace               vif            126 - 144 
Presto / Prestissimo (très) rapide  144 - 208   
(source Wikipédia)
 
 nota :  
 E I S H 5 K = . .. ... .... ..... -.- 
 cdefg = DO RE MI FA SOL (bonjour)
 cge = DO SOL MI (c'est fini) 
 HI = .... .. (hi trois fois)
*/
switch (grafcet_cw) {

// attente caractères
  case 1:
// texte immédiat : on MORSE tout de suite
    if (strlen(cw_texte) > 0) {
      cw_texte_att[0]='\0';
      strcpy(cw_texte_old,cw_texte_att);
      cw_pos=0;
      cwcw = 0;                     // c'est de la musique a priori !
      grafcet_cw = 2;               // et on passe à l'étape suivante
      if (debug > 0) Serial << "CW=" << cw_texte << endl;
    }

  if ( tempo_cw == 0 ) {              // si la tempo est terminée,
// on arme la tempo de surveillance a la vitesse des points, ce qui est suffisant
    tempo_cw = CW_DOTLEN;
// texte temporisé : on MORSE si pas changé depuis tempo_attcw
    if (strlen(cw_texte_att) > 0) {
      if (strcmp(cw_texte_old,cw_texte_att) != 0) {
        strcpy(cw_texte_old,cw_texte_att);
        tempo_attcw = tempo_attcwval;    // durée de stabilité avant manipulation
      }
// le texte temporisé n'a pas changé, la tempo est-elle finie ?
      if ( tempo_attcw == 0 && cw_texte_att[0] != '\0') {
        strcpy(cw_texte,cw_texte_att);
        memset (cw_texte_att,'\0',15);  // RAZ du buffer
      }
    }
  }
  break;

// passage au caractère suivant
  case 2:
  if ( tempo_cw == 0 ) {
// fin de texte
    if (cw_pos >= strlen(cw_texte) or cw_texte[cw_pos] == '\0') {
      memset (cw_texte,'\0',30); // RAZ  du buffer
      grafcet_cw=1;
//      lcd.setCursor(15, 1); lcd << '_';
      break;
    }
    cw = cw_texte[cw_pos];       
    cw_pos++;
// affichage sur le LCD en bas à droite
//    lcd.setCursor(15, 1); lcd << cw ;
 
// caractère suivant
    if (cw == ' ') {
      tempo_cw = 7*CW_DOTLEN;
      if (cwcw == 0) tempo_cw = duree_note;
      grafcet_cw=2;
      break;
    }

#if tone_mode == 1
// duree de notes 
    if ( cwcw == 0 && cw == '$') {
      if (cw_texte[cw_pos] >= '0' && cw_texte[cw_pos] <= '9') {
        duree_note = 75*(1+cw_texte[cw_pos]-'0');
      }
      cw_pos++;
      cw = cw_texte[cw_pos];
      cw_pos++;
    }
// NOTES sous forme 'a' 'a#' 'a3' ou 'a3#'
    if (cwcw == 0 && ((cw >= 'a' && cw <= 'g') || cw == '$') ) {
      i=0; 
      while((note_name[i]!=cw) && (i<7)){ i++; }
      note_freq=note_tone[i]/100.;
// Dièse ?
      if (cw_texte[cw_pos] == '#') {
        note_freq=note_freq*demiton;
        cw_pos++;
      }
// gamme ?
      if (cw_texte[cw_pos] >= '1' && cw_texte[cw_pos] <= '9') {
        if (cw_texte[cw_pos] != '3') note_freq=note_freq*pow(2.,cw_texte[cw_pos]-'3');
        cw_pos++;
      }
// Dièse ?
      if (cw_texte[cw_pos] == '#') {
        note_freq=note_freq*demiton;
        cw_pos++;
      }
      if (debug > 2) Serial << duree_note << "ms " << note_freq << " Hz" << endl;
      if (debug == 2) Serial << note_name[i] << " " << (int) note_freq << "Hz" << endl;
      tone(sortie_gbf, note_freq);  tempo_cw = duree_note;
      grafcet_cw=21;  
      break;

// recherche du pattern du caractère suivant
    } else {
#endif
      cwcw = 1; // c'est de la CW, pas de la musique !
      if (cw >= 'a' && cw <= 'z') cw = cw & 0XDF; // forcage en MAJUSCULES
      for (i=0; i<CW_N_MORSE; i++) {
        if (morsetab[i].c == cw) {
          pw = morsetab[i].pat;
          grafcet_cw++;
        }        
      }
#if tone_mode == 1
    }
#endif
  }    
  break;

// TONE du bit suivant
  case 3:
   if (tempo_cw == 0) {
    if (pw != 1) {
// TIT ou TAAH
      if (pw & 1) tempo_cw = CW_DASHLEN; else tempo_cw = CW_DOTLEN;
#if tone_mode == 1
      if (pw & 1) tone(sortie_gbf, CW_PITCH_TAAH); else tone(sortie_gbf, CW_PITCH);
#else
      digitalWrite(sortie_gbf, HIGH) ;
#endif
      pw = pw / 2 ;
      grafcet_cw++;
// silence inter-caractères
    } else {
      tempo_cw = 2*CW_DOTLEN;  
      grafcet_cw=2; 
    }
   }
  break;

// silence 1 TAAH
  case 4:
    if (tempo_cw == 0) { 
#if tone_mode == 1
      noTone(sortie_gbf); 
#else
      digitalWrite(sortie_gbf, LOW);
#endif
      tempo_cw = CW_DOTLEN;  
      grafcet_cw=3; 
    }
  break;

// fin d'une note : silence très court
  case 21:
    if (tempo_cw == 0) { 
#if tone_mode == 1
      noTone(sortie_gbf); 
#else
digitalWrite(sortie_gbf, LOW);
#endif
      tempo_cw = duree_note/15; 
      grafcet_cw=2; 
    }
  break;

// FIN, arrÃƒÂªt CW
// si grafcet_cw n'a pas une valeur correcte, on passe ici
  default: 
  case 9999:
#if tone_mode == 1
    noTone(sortie_gbf); 
#else
    digitalWrite(sortie_gbf, LOW);
#endif
    grafcet_cw=0;  
    break;
}      // fin du "switch"
 
// FIN GRAFCET MORSE CW
//--------------------------------********************--------------------------------
#if tone_mode == 1
switch (grafcet_bigben) {
// inits selon selon quart d'heure (voir decl1300_morse.h)
   case 1 :
    bigben_n == minute()/15;    // quel quarter ?
    if (minute() != bigben_n*15 ) {
      grafcet_bigben = 0;      // c'est pas un quart !
    } else {
     bigben_i = bigben_debut[bigben_n];
     grafcet_bigben++;
    }
    break;

// chimes
  case 2 :
    if (grafcet_cw == 1) {
      if (debug >0) {horodatage_serial(); Serial << "BIGBEN_chime=" << bigben_i << endl;}
      strcpy(cw_texte,bigben_chime[bigben_i]);
      if (bigben_i == bigben_fin[bigben_n]) grafcet_bigben++;    // c'est fini
      bigben_i++;
      if (bigben_i > 4) bigben_i=0;
    }
    break;

// init heure ou fin
  case 3 :
    if (grafcet_cw == 1) {
      if (bigben_n == 0) {
        bigben_i = hour();
        if ( bigben_i == 0 ) bigben_i = 12;
        if ( bigben_i > 12 ) bigben_i -= 12;
        if (debug >0) {horodatage_serial(); Serial << "BIGBEN heure=" << bigben_i << endl;}
        grafcet_bigben++;
      } else {
        grafcet_bigben=0;    // FIN
      }
    }
    break;
    
// heure
  case 4 :
    if (grafcet_cw == 1) {
      if (bigben_i > 0) {
        strcpy(cw_texte,bigben);
        bigben_i--;
      } else {
        grafcet_bigben=0;    // FIN
      }
    }
  break;  
}
#endif
//--------------------------------********************--------------------------------



