/* V 11.06.2013
     Afficheur LCD-jumbo "récupération CANT COURBON 1993"
*/
//************************************************
// DEBUT DE ZONE MODIFIABLE SELON CONFIGURATION
//************************************************
/* nombre de modules de 6 digits gérés
 0= 1 module avec CS non commandé, tiré par résistance // à voir lcdjx pour calculs ???
 1= 1 module avec CS commandé
 2= 2 modules avec CS commandé
 3= 3 modules avec CS commandé
*/
#define lcdjx 3

// nombre de digits par module
#define lcdj_nbd 6

// definition des entrées sorties pour un ARDUINO MEGA
#define lcdj_0 32	// (UNO 2) poids faible
#define lcdj_1 33       // (UNO 3)
#define lcdj_2 34       // (UNO 4)
#define lcdj_3 35	// (UNO 5) poids fort
#define lcdj_WE 36	// (UNO 6) commande d'écriture
#if lcdjx > 0
#define lcdj_CS1 37  // (UNO 7) non utilisé si un seul afficheur (tirer à la masse)
#endif
#if lcdjx > 1
#define lcdj_CS2 38  // (UNO 8) pour le 2° module
#endif
#if lcdjx > 2
#define lcdj_CS3 39  // (UNO 9) pour le 3° module
#endif

//************************************************
// FIN DE ZONE MODIFIABLE
//************************************************
//#define lcdj_RE 40  // non utilisé (tirer au +5 Volt)
//#define lcdj_READY 41  // non utilisé (laisser en l'air)
#define lcdj lcdjx
#if lcdj == 0
#define lcdj 1
#endif

// tempo en microsecondes entre commandes lcd
#define lcdj_delay 25 // 7 au moins, 25 à 50 est plus sûr ! 
// la notice indique 2,5 à 3,5 microsec.

/*
Assez bizarrement, les 8 segments d'un digit ne sont pas contigus dans la mémoire. 
Cela vient d'une simplification hazardeuse de la conception du circuit imprimé entre le contrôleur et le verre LCD.
Les 3 segments inférieurs et le point de 2 digits contigus sont dans le même octet (0,1,2)
Les 4 segments supérieurs sont sur dautres ovtets (6,5,4)
Par ailleurs, des : existent sur le verre entre les digits 1 et 2 et aussi 3 et 4, mais ne sont pas câblés, 
bien que le contrôleur puisse piloter 8 digits complets .
D'où le système donnant le numero de bit dans la RAM correspondant à chaque segment de chaque digit 
pour a,b,c,d,e,f,g,p(DP) iseg=0 à 7, et la formule est :
ibit_ram = lcdj_segcst[iseg].seg0 + lcdj_segcst[iseg].seg1 * idigit%lcdj_nbd;
*/
struct lcdjsegcst { int seg0, seg1; } ;
struct lcdjsegcst lcdj_segcst[] = {
  	{45, -4},  //a
  	{44, -4},  //b
  	{2, 4},    //c
  	{1, 4},    //d
  	{0, 4},    //e
  	{46, -4},  //f
  	{47, -4},  //g
  	{3, 4}     //p (DP)
};

// Ensuite, il nous faut une table donnant les segments à allumer en fonction du caractère à afficher :
struct lcdjseg { byte c; byte seg; } ;
// classer en ordre alphabétique pour recherche dichotomique
struct lcdjseg lcdj_seg[] = {
//       'X', Bpgfedcba      SIGNES DIVERS
	{' ', B00000000},   // premier caractère pris par défaut si pas trouvé !
	{'+', B00000001},    // tiret du haut
	{'-', B01000000},    // tiret du milieu
	{'=', B01001000},
	{'?', B01010011},
//       'X', Bpgfedcba    CHIFFRES
  	{'0', B00111111},
	{'1', B00000110},
	{'2', B01011011},
	{'3', B01001111},
	{'4', B01100110},
	{'5', B01101101},
	{'6', B01111101},
	{'7', B00000111},
	{'8', B01111111},      
	{'9', B01101111},  
//       'X', Bpgfedcba    LETTRES (les minuscules sont automatiquement affichées comme les majuscules)
	{'A', B01110111},  // A 
	{'B', B01111100},  // b                  schema et noms des segments
	{'C', B00111001},  // C    ***a***
	{'D', B01011110},  // d    *     *
	{'E', B01111001},  // E    f     b
	{'F', B01110001},  // F    ***g***
	{'G', B00111101},  // g    *     *
	{'H', B01110110},  // h    e     c
	{'I', B00000100},  // i    ***d***  p (point decimal)
	{'J', B00011110},  // J
	{'K', B01110000},  // K (pas génial)
	{'L', B00111000},  // L 
	{'M', B00110111},  // M
	{'N', B01010100},  // n
  	{'O', B01011100},  // o
  	{'P', B01110011},  // P
  	{'Q', B01100111},  // q
  	{'R', B01010000},  // r
	{'S', B01101101},  // S
	{'T', B01111000},  // t
	{'U', B00011100},  // u
	{'V', B00111110},  // V
	{'W', B01111110},  // W
	{'X', B01010010},  // X (pas très génial !)
	{'Y', B01100110},  // Y
	{'Z', B01011011},  // Z idem au 5
//       'X', Bpgfedcba
	{'_', B00001000},    // tiret du bas
	{'°', B01100011}    // °degrés °C
//	{'\xB0', B01100011}    // °degrés ??? pas reconnu !!!
     } ;
//       'X', Bpgfedcba
//	{'.', B10000000},  // point seul (gestion particulière)
// variantes
//	{'A', B01011111},  // a 
//	{'C', B01011000},  // c    
//	{'E', B01111011},  // e    
// nombre de caractères définis
#define lcdj_seg_nb  (sizeof(lcdj_seg)/sizeof(lcdj_seg[0]))

// table des bits de RAM du lcd jumbo (6 digits de 8 bits + 2 deux-points ::)
byte lcdj_ram[lcdj*(lcdj_nbd+1)],lcdj_ramv[lcdj*(lcdj_nbd+1)];
// edcpbafgedcpbafgedcpbafgedcpbafgedcpbafgedcpbafg::______
// 01234567890123456789012345678901234567890123456789012345
// 00000000111111112222222233333333444444445555555566666666

// drapeaux de mise à jour octe/octet de ram
boolean lcdj_maj[lcdj*(lcdj_nbd+1)];

// buffer des caractères à afficher
// ce buffer comporte : 6 caractères, 6 points, 2 deux-points, une fin (un null pour éviter les ennuis lors d'envoi sur Serial!)
// '111111222222333333'='ABCDEF123456ABCDEF\0'
char lcdj_buf[lcdj*lcdj_nbd+1],lcdj_bufv[lcdj*lcdj_nbd+1];

// buffer des points décimaux '111111222222333333'='.....!.....!.....!\0'
char lcdj_bufdp[lcdj*lcdj_nbd+1],lcdj_bufdpv[lcdj*lcdj_nbd+1];

// buffer des deux-points (semi-colon) '112233'='::::::\0'
char lcdj_bufco[lcdj*2+1],lcdj_bufcov[lcdj*2+1];

/* ATTENTION !
Il faut être très prudent quand on manipule les chaines de caractères.
Tout débordement se traduit par un comportement erratique et anormal de l'ARDUINO, 
  se terminant en génral par un crash et reboot.
On a donc intérêt à utiliser 'strncpy' et 'strncat' pour limiter le nombre de caractères recopiés,
  et à terminer les chaines par '\0' (d'où une longueuer+1 que j'utilise dans les déclarations)
*/

//--------------------------------********************--------------------------------
// positionne les bits nécessaires pour un 'digit' représenttant 'car'
void lcdj_affiche_digit (byte car, int digit) {
// digit va de 0 à lcdj_nbd pour 1 module et de 0 à lcdj*lcdj_nbd
byte segments,masque,masquex;
int ibit,ioctet,i;

// conversion minuscules -> majuscules
  segments=car; if (car >= 'a' && car <= 'z') segments = (car & 0x9F) | 0x40 ;

// recherche caractère à afficher, si on ne trouve pas, on prends le 1° (c'est ' ') 
  i=lcdj_seg_nb-1;
  if ((segments < lcdj_seg[i-8].c) && (i > 8)) { i-=8; }    // accélérateur pseudo-dichotomique
  while ((segments != lcdj_seg[i].c) && (i > 0)) { i--; }   // recherche séquentielle

// récupération des états des segments pour ce caractère
  segments = lcdj_seg[i].seg;
//  if ( segments!=0)Serial << digit << "=digit car=" << car << " segments=" << _HEX(segments) << endl;

// transfert des état des 7 segments dans le buffer RAM (donc sauf le point decimal, traités plus loin)
// masque à 1 bit positionné sur le bit entrée
  masque=0B00000001;
  for (i=0;i<7;i++) {
// position du bit destination ou cible
      ibit = lcdj_segcst[i].seg0 + lcdj_segcst[i].seg1*(digit%lcdj_nbd);  ////
//     Serial << "ibit=" << ibit;
// NO octet et NO bit dans l'octet destination
      ioctet = (ibit/8) + (digit/lcdj_nbd)*(lcdj_nbd+1);    // octet cible : 0à5 selon bit, + decalage module
      ibit = ibit%8;    // position relative du bit dans l'octet cible

// masque à 1 bit positionné sur le bit de l'octet destination
      masquex = 0B10000000>>ibit;
//     Serial << " ibit=" << ibit << " ioctet=" << ioctet << " masquex=" << _HEX(masquex);
// mise a jour table RAM lcdj
      if (segments & masque) {lcdj_ram[ioctet] = lcdj_ram[ioctet] | masquex;} else {lcdj_ram[ioctet] = lcdj_ram[ioctet] & ~masquex;}
//     Serial << " " << _HEX((segments & masque)) << " lcdj_ram[ioctet]=" << _HEX(lcdj_ram[ioctet]) << endl;
// drapeau de mise à jour
      lcdj_maj[ioctet] = true;
// décalage pour bit suivant
      masque = masque<<1;
  }
}
//--------------------------------********************--------------------------------
// envoi des 4 octets de "value" au lcd JUMBO 
void lcdj_quartet(int value) {
// value = 4 octets à traiter
int val,i;
//Serial << "lcdj_quartet(" << _HEX(value) << endl;
// pour les 4 octets
  for (i=3;i>=0;i--) {

// décalage à droite selon quartet à envoyer
    val = value >> 4*i;
// Serial << i << " quartet=" << _HEX(val & 0x0000000F) << endl;
    digitalWrite(lcdj_0, val & 1);
    val = val >> 1; digitalWrite(lcdj_1, val & 1);
    val = val >> 1; digitalWrite(lcdj_2, val & 1);
    val = val >> 1; digitalWrite(lcdj_3, val & 1);

    delayMicroseconds(lcdj_delay);    digitalWrite(lcdj_WE, LOW);    // impulsion pour écrire
    delayMicroseconds(lcdj_delay);    digitalWrite(lcdj_WE, HIGH);    // fin impulsion
}
return;
}
//--------------------------------********************--------------------------------
// sous-programme qui surveille si on doit afficher quelquechose
// appeler ce module dans la boucle principale, toutes les 100ms est suffisant
void lcdj_affiche() {
//void lcdj_envoi_ram() {
 byte masquex;
 int digit,ibit,ioctet;

// pour eviter les crashes ...
   lcdj_buf[sizeof(lcdj_buf)-1] = '\0';

// si un caractère a bougé
 if (strcmp(lcdj_bufv,lcdj_buf) !=0) {
 // traitement des caractères "normaux"   
   for (digit=0;digit<lcdj*lcdj_nbd;digit++) {
     lcdj_affiche_digit (lcdj_buf[digit],digit);
//   Serial << "digit=" << digit << " " << lcdj_buf[digit] << endl;
   }
  }

// POINT DECIMAUX
 if (strcmp(lcdj_bufdpv,lcdj_bufdp) !=0) {
// traitement des 6 points dont le 6° n'existe pas pour nous 'xxxxxx.....!xx'
  for (digit=0; digit<lcdj*lcdj_nbd; digit++) {
    if (lcdj_bufdp[digit] != lcdj_bufdpv[digit]) {
// position du bit destination ou cible
      ibit = lcdj_segcst[7].seg0 + lcdj_segcst[7].seg1*(digit%lcdj_nbd);
// NO octet et NO bit dans l'octet destination
      ioctet = (ibit/8) + (digit/lcdj_nbd)*(lcdj_nbd+1);    // octet cible : 0à5 selon bit, + decalage module
      ibit = ibit%8;    // position relative du bit dans l'octet cible
// masque à 1 bit positionné sur le bit de l'octet destination
      masquex = 0B10000000>>ibit;
// mise a jour table RAM lcdj
      if (lcdj_bufdp[digit] != ' ' && lcdj_bufdp[digit] != '\0') {lcdj_ram[ioctet] = lcdj_ram[ioctet] | masquex;} else {lcdj_ram[ioctet] = lcdj_ram[ioctet] & ~masquex;}
// drapeau de mise à jour
      lcdj_maj[ioctet] = true;
// mémoire
//      lcdj_bufdpv[digit] = lcdj_bufdp[digit];
    }
  }
 }
  
// traitement des : '::'
// traitement des : '::::::'
//                   012345678901234567890123456789
//->                 111111:222222:333333:
 if (strcmp(lcdj_bufcov,lcdj_bufco) !=0) {
  for (digit=0; digit<lcdj*2; digit++) {
    if (lcdj_bufco[digit] != lcdj_bufcov[digit]) {
// position du bit destination ou cible
      ibit = 6;  if (digit & 0x01) ibit=7;
// NO octet dans l'octet destination
      ioctet = lcdj_nbd + (digit>>1)*(lcdj_nbd+1);
// masque à 1 bit positionné sur le bit de l'octet destination
      masquex = 0B00000001<<ibit;
//      if (ioctet==20 || ioctet==13) Serial << digit << "=digit ioctet=" << ioctet << " ibit=" << ibit << endl;
// mise a jour table RAM lcdj
      if (lcdj_bufco[digit] != ' ' && lcdj_bufco[digit] != '\0') {lcdj_ram[ioctet] = lcdj_ram[ioctet] | masquex;} else {lcdj_ram[ioctet] = lcdj_ram[ioctet] & ~masquex;}
//      if (ioctet==20 || ioctet==13) Serial << lcdj_bufco[digit] << "=bufco " << _BIN(masquex) << "=mask ram=" << _BIN(lcdj_ram[ioctet]) << endl;
// drapeau de mise à jour
      lcdj_maj[ioctet] = true;
// mémoire
//      lcdj_bufcov[digit] = lcdj_bufco[digit];
    }
  }
 }

// ENVOI DES DIGITS QUI ONT BOUGE
    for (ioctet=0; ioctet<lcdj*(lcdj_nbd+1);ioctet++) {

// si a changé ou bougé
      if (lcdj_maj[ioctet]) {

// validation du chip HITACHI concerné
  digit = ioctet/(lcdj_nbd+1);    // en fait ici, No de module
//  if (ioctet==20 || ioctet==13) Serial << ioctet << "ioctet module=" << digit <<  " ram=" << _BIN(lcdj_ram[ioctet]) << endl;
#if lcdjx > 2
   if (digit == 2) digitalWrite(lcdj_CS3, LOW);    // validation chip
#endif
#if lcdjx > 1
   if (digit == 1) digitalWrite(lcdj_CS2, LOW);    // validation chip
#endif
#if lcdjx > 0
   if (digit == 0) digitalWrite(lcdj_CS1, LOW);    // validation chip
   delayMicroseconds(lcdj_delay);    
#endif

// envoi des données
//        if ( lcdj_ram[ioctet]!=0) Serial << "ioctet=" << ioctet << "<" << _HEX(lcdj_ram[ioctet]) << ">" << endl;
      lcdj_quartet(0x0100*(ioctet%(lcdj_nbd+1)) + lcdj_ram[ioctet]);
// raz du flag de bougement (ou bougeage ?), euh changement !
      lcdj_maj[ioctet] = false;

#if lcdjx > 0
       delayMicroseconds(lcdj_delay);    
       if (digit == 0) digitalWrite(lcdj_CS1, HIGH);    // dé-validation chip
#endif
#if lcdjx > 1
       if (digit == 1) digitalWrite(lcdj_CS2, HIGH);    // dé-validation chip
#endif
#if lcdjx > 2
       if (digit == 2) digitalWrite(lcdj_CS3, HIGH);    // dé-validation chip
#endif
      }
    }

// mise en mémoire
   strcpy(lcdj_bufv,lcdj_buf); strcpy(lcdj_bufdpv,lcdj_bufdp); strcpy(lcdj_bufcov,lcdj_bufco);
}
//--------------------------------********************--------------------------------
// tout éteindre ou allumer avec 'car'
void lcdj_clear(byte car) {
  byte cari;
  cari=car;
     if (car < ' ' && car != '\0') cari = ' ';
     
     memset (lcdj_buf,cari,sizeof(lcdj_buf)-1);
     lcdj_buf[sizeof(lcdj_buf)-1]='\0';

     memset (lcdj_bufdp,cari,sizeof(lcdj_bufdp)-1);
     lcdj_bufdp[sizeof(lcdj_bufdp)-1]='\0';

     memset (lcdj_bufco,cari,sizeof(lcdj_bufco)-1);
     lcdj_bufco[sizeof(lcdj_bufco)-1]='\0';
}
//--------------------------------********************--------------------------------
// initialisation du LCD JUMBO
void lcdj_init() {
int i,j,k;

// Définition des e/s
  pinMode(lcdj_0, OUTPUT);
  pinMode(lcdj_1, OUTPUT);
  pinMode(lcdj_2, OUTPUT);
  pinMode(lcdj_3, OUTPUT);
  pinMode(lcdj_WE, OUTPUT);
#if lcdjx > 0
  pinMode(lcdj_CS1, OUTPUT);
#endif
#if lcdjx > 1
  pinMode(lcdj_CS2, OUTPUT);
#endif
#if lcdjx > 2
  pinMode(lcdj_CS3, OUTPUT);
#endif

// init des HITACHI LCD, tous validés
    digitalWrite(lcdj_WE, HIGH);
#if lcdjx > 0
    digitalWrite(lcdj_CS1, LOW);
#endif
#if lcdjx > 1
    digitalWrite(lcdj_CS2, LOW);
#endif
#if lcdjx > 2
    digitalWrite(lcdj_CS3, LOW);
#endif

// reset compteur de quartets
    i=0xCCCC; lcdj_quartet(i);
// mode setting (deux fois , selon notice)
    i=0x8400; lcdj_quartet(i);
    i=0x8400; lcdj_quartet(i);

// dévalidation des CS
#if lcdjx > 0
    digitalWrite(lcdj_CS1, HIGH);
#endif
#if lcdjx > 1
    digitalWrite(lcdj_CS2, HIGH);
#endif
#if lcdjx > 2
    digitalWrite(lcdj_CS3, HIGH);
#endif

// init buffers
     lcdj_buf[sizeof(lcdj_buf)-1]='\0';
     memset (lcdj_bufv,'\0',sizeof(lcdj_buf));
// buffer des points décimaux
     lcdj_bufdp[sizeof(lcdj_bufdp)-1]='\0';
     memset (lcdj_bufdpv,'\0',sizeof(lcdj_bufdp));
// buffer des deux-points (semi-colon)
     lcdj_bufco[sizeof(lcdj_bufco)-1]='\0';
     memset (lcdj_bufcov,'\0',sizeof(lcdj_bufco));
// TEST de démarrage
// tout allumer
     lcdj_clear('8');
     lcdj_affiche();
     delay(300);
// tout éteindre
     lcdj_clear(' ');
     lcdj_affiche();
}

//--------------------------------********************--------------------------------


